#include "proxy.h"

void proxy_startListener(unsigned int port){

	int server_fd, new_socket;
    struct sockaddr_in address;
    int opt = 1;
    int addrlen = sizeof(address);
	char *response;

    // Creating socket file descriptor
    if ((server_fd = socket(AF_INET, SOCK_STREAM, 0)) == 0) {
        perror("socket failed");
		return ;
    }

    address.sin_family = AF_INET;
    address.sin_addr.s_addr = INADDR_ANY;
    address.sin_port = htons( port );

    // Forcefully attaching socket to the port 8080
    if (bind(server_fd, (struct sockaddr *)&address, sizeof(address)) != 0) {
        perror("bind failed");
		return ;
    }

    if (listen(server_fd, 3) != 0) {
        perror("listen");
		return ;
    }

	while ( true ){
		printf("Listening\n");
		if ((new_socket = accept(server_fd, (struct sockaddr *)&address, 
				(socklen_t*)&addrlen))<0) {
			perror("accept");
			return ;
		}

		Request *request = newRequestFromSocket(new_socket);

		if ( strcmp( request->host, "" ) == 0 ){
			response = webserverGetResponse(request);
		} else {
			printf("This is a proxy request\n");
		}

		send(new_socket , response, strlen(response) , 0 );


		//close(new_socket);
	}

}
