#include "requestresponse.h"

Header* newHeader(char *str){
	Header *header = malloc(sizeof(Header));
	memset(header, 0, sizeof(Header));

	int position = -1;


	for ( unsigned int i = 0; i < strlen(str); i++ ){
		if ( str[i] == ':' ){
			position = i;
			break;
		}
	}

	if ( position == -1 ){
		printf("Header without colon. Not sure what to do\n");
		return NULL;
	}


	// We want to allocate 1 more than the length so we can have a \0 at the end
	header->name = malloc( sizeof(char) * ( position + 1 ) );
	memset(header->name, '\0', position+1);
	strncpy( header->name, str, position );

	for ( unsigned int i = position+1; i < strlen(str); i++ ){
		if ( str[i] == '\t' || str[i] == ' ' ) continue;
		position = i;
		break;
	}


	//Anything left is the value
	header->value = malloc( sizeof(char) * ( strlen(str) - position ) );
	memset(header->value, '\0', ( strlen(str) - position ) );
	strcpy( header->value, str + position );

	return header;
}

void addHeader(HeaderList *headers, char *str){
	HeaderList *newListItem = malloc(sizeof(HeaderList));

	newListItem->header = newHeader(str);
	newListItem->next = NULL;

	HeaderList *last = headers;

	while ( last->next != NULL ) last = last->next;

	last->next = newListItem;
}


// Will return the first header in a header list with the name matching name
// It matches name case insensitively as header names are case insensitive

Header* getHeader(HeaderList *headers, char *name){
	HeaderList *curr = headers;
	while ( curr != NULL ){
		// Header names are case insensitive
		if ( strcasecmp( curr->header->name, name) == 0 ){
			return curr->header;
		}
		curr = curr->next;
	}
	return NULL;
}


unsigned int countHeaders(HeaderList *headers){
	unsigned int count = 0;
	while (headers != NULL){
		count++;
		headers = headers->next;
	}
	return count;
}

unsigned int headerListCharLength(HeaderList *headers){
	unsigned int length = 0;
	while (headers != NULL){
		// 4 = colon + space + \r + \n
		length += strlen(headers->header->name) + strlen(headers->header->value) + 4;
		headers = headers->next;
	}
	return length;
}


char* headersToString(HeaderList *headers){
	int len = headerListCharLength(headers) + 1; //null pointer
	HeaderList *curr = headers;
	char *retStr = malloc( len * sizeof(char) );
	memset(retStr, '\0', len * sizeof(char) );
	while ( curr != NULL ){
		strcat( retStr, curr->header->name );
		strcat( retStr, ": " );
		strcat( retStr, curr->header->value );
		strcat( retStr, "\r\n" );
		curr = curr->next;
	}
	return retStr;
}
